﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Helpers;
using System.Web.Mvc;

namespace WebGrid_Dynamic_Columns_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            //Fetch the names of Columns from Entity model.
            string[] columnNames = typeof(Customer).GetProperties().Select(property => property.Name).ToArray();

            //Add Dynamic Columns to List collection.
            List<WebGridColumn> columns = new List<WebGridColumn>();
            columns.Add(new WebGridColumn() { ColumnName = columnNames[0], Header = columnNames[0] }); //CustomerID
            columns.Add(new WebGridColumn() { ColumnName = columnNames[2], Header = columnNames[2] }); //ContactName
            columns.Add(new WebGridColumn() { ColumnName = columnNames[5], Header = columnNames[5] }); //City 
            columns.Add(new WebGridColumn() { ColumnName = columnNames[8], Header = columnNames[8] }); //Country

            //Assign the List of Dynamic WebGrid Columns to ViewBag.
            ViewBag.Columns = columns;

            NorthwindEntities entities = new NorthwindEntities();
            return View(entities.Customers.ToList());
        }
    }
}